package vm

import (
	"context"
	"fmt"
	"github.com/pkg/errors"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/helper/xerr"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/repository/result"
	"gitlink.org.cn/JointCloud/pcm-openstack/openstack"

	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/svc"
	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/types"

	"github.com/zeromicro/go-zero/core/logx"
)

type GetImageNumLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

func NewGetImageNumLogic(ctx context.Context, svcCtx *svc.ServiceContext) *GetImageNumLogic {
	return &GetImageNumLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *GetImageNumLogic) GetImageNum(req *types.ListImagesReq) (resp *types.ImageNum, err error) {
	// todo: add your logic here and delete this line
	resp = &types.ImageNum{}
	listImagesReq := &openstack.ListImagesReq{}
	listImagesReq.Platform = req.Platform
	//err = copier.CopyWithOption(ListImagesReq, req, copier.Option{Converters: utils.Converters})
	ListImagesResp, err := l.svcCtx.OpenstackRpc.ListImages(l.ctx, listImagesReq)
	if err != nil {
		return nil, errors.Wrapf(xerr.NewErrMsg("Failed to get Networks list"), "Failed to get db Servers list err : %v ,req:%+v", err, req)
	}
	var count int = len(ListImagesResp.Images)
	resp.ImageNum = int32(count)
	fmt.Println(count)
	if err != nil {
		return nil, result.NewDefaultError(err.Error())
	}
	return resp, err
}
